'use strict';

require('effect');
var constants_js = require('./constants.cjs');

const isServer = () => typeof window === "undefined";
const hasPrivateAccessToken = (fields) => "privateAccessToken" in fields;
const hasPublicAccessToken = (fields) => "publicAccessToken" in fields;
const isQuery = (query) => constants_js.IS_QUERY_RE.test(query);
const isMutation = (mutation) => constants_js.IS_MUTATION_RE.test(mutation);

exports.hasPrivateAccessToken = hasPrivateAccessToken;
exports.hasPublicAccessToken = hasPublicAccessToken;
exports.isMutation = isMutation;
exports.isQuery = isQuery;
exports.isServer = isServer;
//# sourceMappingURL=predicates.cjs.map
//# sourceMappingURL=predicates.cjs.map