'use strict';

var Effect = require('effect/Effect');
var FiberRef = require('effect/FiberRef');
require('effect/LogLevel');

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}

var Effect__namespace = /*#__PURE__*/_interopNamespace(Effect);
var FiberRef__namespace = /*#__PURE__*/_interopNamespace(FiberRef);

const filterLevelOrNever = (level, effect) => Effect__namespace.gen(function* () {
  const logLevel = yield* FiberRef__namespace.get(FiberRef__namespace.currentMinimumLogLevel);
  if (logLevel._tag !== level._tag) return yield* effect;
});
const withNamespacedLogSpan = (label) => Effect__namespace.withLogSpan(`[@solidifront/storefront-client]:${label}`);

exports.filterLevelOrNever = filterLevelOrNever;
exports.withNamespacedLogSpan = withNamespacedLogSpan;
//# sourceMappingURL=LoggerUtils.cjs.map
//# sourceMappingURL=LoggerUtils.cjs.map