'use strict';

var StorefrontOperation = require('./services/StorefrontOperation.cjs');
var Effect = require('effect/Effect');
var storefront_js = require('./utils/storefront.cjs');

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}

var StorefrontOperation__namespace = /*#__PURE__*/_interopNamespace(StorefrontOperation);
var Effect__namespace = /*#__PURE__*/_interopNamespace(Effect);

const extractOperationName = (operation) => Effect__namespace.runSync(StorefrontOperation__namespace.extractName(operation));
const minifyOperation = (operation) => Effect__namespace.runSync(StorefrontOperation__namespace.minify(operation));

Object.defineProperty(exports, "buildShopDomain", {
  enumerable: true,
  get: function () { return storefront_js.buildShopDomain; }
});
Object.defineProperty(exports, "buildStorefrontApiUrl", {
  enumerable: true,
  get: function () { return storefront_js.buildStorefrontApiUrl; }
});
exports.extractOperationName = extractOperationName;
exports.minifyOperation = minifyOperation;
//# sourceMappingURL=utils.cjs.map
//# sourceMappingURL=utils.cjs.map