// Generated by dts-bundle-generator v9.5.1

import { HttpBodyError } from '@effect/platform/HttpBody';
import * as HttpClient from '@effect/platform/HttpClient';
import { HttpClient as HttpClient$1 } from '@effect/platform/HttpClient';
import { HttpClientError } from '@effect/platform/HttpClientError';
import * as Context from 'effect/Context';
import * as Data from 'effect/Data';
import * as Effect from 'effect/Effect';
import * as Layer from 'effect/Layer';
import { Layer as Layer$1 } from 'effect/Layer';
import { ParseError } from 'effect/ParseResult';
import * as Redacted from 'effect/Redacted';
import * as S from 'effect/Schema';
import { Scope } from 'effect/Scope';

export interface CodegenOperations {
	[key: string]: any;
}
export interface StorefrontQueries extends CodegenOperations {
}
export interface StorefrontMutations extends CodegenOperations {
}
export type ClientOptions = typeof ClientOptions;
export type GraphQLJsonBody = S.Schema.Type<typeof GraphQLJsonBody>;
export type RequestOptionsWithoutVariables = Omit<S.Schema.Encoded<typeof RequestOptions>, "variables">;
export type RequestOptions<TVariables = any> = TVariables extends {
	[key: string]: never;
} | undefined | never ? RequestOptionsWithoutVariables : Omit<S.Schema.Encoded<typeof RequestOptions>, "variables"> & {
	variables: TVariables;
};
declare const ClientOptions: S.Schema<{
	readonly apiVersion: "2024-01" | "2024-04" | "2024-07" | "2024-10" | "2025-01" | "unstable";
	readonly storeName: string;
	readonly retries: number;
	readonly contentType: "json" | "graphql";
} & {
	readonly privateAccessToken?: Redacted.Redacted<string> | undefined;
	readonly publicAccessToken?: string | undefined;
}, {
	readonly storeName: string;
	readonly apiVersion?: "2024-01" | "2024-04" | "2024-07" | "2024-10" | "2025-01" | "unstable" | undefined;
	readonly retries?: number | undefined;
	readonly contentType?: "json" | "graphql" | undefined;
} & {
	readonly privateAccessToken?: string | undefined;
	readonly publicAccessToken?: string | undefined;
}, never>;
declare const GraphQLJsonBody: S.Struct<{
	data: S.optional<typeof S.Unknown>;
	extensions: S.optional<S.Record$<typeof S.String, typeof S.Any>>;
	errors: S.optional<S.Array$<S.Struct<{
		message: typeof S.NonEmptyString;
		locations: S.optional<S.Array$<S.Struct<{
			line: typeof S.Int;
			column: typeof S.Int;
		}>>>;
		extensions: S.optional<S.Struct<{
			code: typeof S.NonEmptyString;
		}>>;
	}>>>;
}>;
declare const RequestOptions: S.SchemaClass<{
	readonly privateAccessToken?: Redacted.Redacted<string> | undefined;
	readonly publicAccessToken?: string | undefined;
	readonly apiVersion?: "2024-01" | "2024-04" | "2024-07" | "2024-10" | "2025-01" | "unstable" | undefined;
	readonly storeName?: string | undefined;
	readonly contentType?: "json" | "graphql" | undefined;
	readonly buyerIp?: string | undefined;
	readonly variables?: {
		readonly [x: string]: any;
	} | undefined;
	readonly signal?: AbortSignal | undefined;
}, {
	readonly privateAccessToken?: string | undefined;
	readonly publicAccessToken?: string | undefined;
	readonly apiVersion?: "2024-01" | "2024-04" | "2024-07" | "2024-10" | "2025-01" | "unstable" | undefined;
	readonly storeName?: string | undefined;
	readonly contentType?: "json" | "graphql" | undefined;
	readonly buyerIp?: string | undefined;
	readonly variables?: {
		readonly [x: string]: any;
	} | undefined;
	readonly signal?: AbortSignal | undefined;
}, never>;
export interface IFetchBodyResponse<TData = any> {
	data?: TData;
	extensions?: Record<string, any>;
}
export interface IResponseErrors {
	networkStatusCode?: number;
	message?: string;
	graphQLErrors?: GraphQLJsonBody["errors"];
}
export interface IClientResponse<TData = any> extends IFetchBodyResponse<TData> {
	errors?: IResponseErrors;
}
declare class ClientResponse<TData = any> extends Data.Class<IClientResponse<TData>> {
}
declare const BadRequestStatusError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "BadRequestStatusError";
} & Readonly<A>;
export declare class BadRequestStatusError extends BadRequestStatusError_base<{
	message: string;
	status: 400;
}> {
	static readonly status = 400;
	constructor();
}
declare const PaymentRequiredStatusError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "PaymentRequiredStatusError";
} & Readonly<A>;
export declare class PaymentRequiredStatusError extends PaymentRequiredStatusError_base<{
	message: string;
	status: 402;
}> {
	static readonly status = 402;
	constructor();
}
declare const ForbiddenStatusError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "ForbiddenStatusError";
} & Readonly<A>;
export declare class ForbiddenStatusError extends ForbiddenStatusError_base<{
	message: string;
	status: 403;
}> {
	static readonly status = 403;
	constructor();
}
declare const NotFoundStatusError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "NotFoundStatusError";
} & Readonly<A>;
export declare class NotFoundStatusError extends NotFoundStatusError_base<{
	message: string;
	status: 404;
}> {
	static readonly status = 404;
	constructor();
}
declare const LockedStatusError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "LockedStatusError";
} & Readonly<A>;
export declare class LockedStatusError extends LockedStatusError_base<{
	message: string;
	status: 423;
}> {
	static readonly status = 423;
	constructor();
}
declare const RetriableStatusCodesError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "RetriableStatusCodesError";
} & Readonly<A>;
export declare class RetriableStatusCodesError extends RetriableStatusCodesError_base<{
	message: string;
	status: number;
}> {
	static readonly validStatuses: number[];
	constructor(status: number);
}
declare const StorefrontServerStatusError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "StorefrontServerStatusError";
} & Readonly<A>;
export declare class StorefrontServerStatusError extends StorefrontServerStatusError_base<{
	message: string;
	status: number;
}> {
	constructor(status: number);
}
declare const AssertQueryError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "AssertQueryError";
} & Readonly<A>;
export declare class AssertQueryError extends AssertQueryError_base<{
	message: string;
	query: string;
}> {
	constructor(query: string);
}
declare const AssertMutationError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "AssertMutationError";
} & Readonly<A>;
export declare class AssertMutationError extends AssertMutationError_base<{
	message: string;
	mutation: string;
}> {
	constructor(mutation: string);
}
declare const ExtractOperationNameError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<A, {}> extends true ? void : {
	readonly [P in keyof A as P extends "_tag" ? never : P]: A[P];
}) => import("effect/Cause").YieldableError & {
	readonly _tag: "ExtractOperationNameError";
} & Readonly<A>;
export declare class ExtractOperationNameError extends ExtractOperationNameError_base<{
	message: string;
}> {
	constructor(operation: string);
}
export type MakeResult = Effect.Effect<{
	request: <const Operation extends string, TVariables extends {
		[x: string]: never;
	}, TData = any>(operation: Operation, options?: RequestOptions<TVariables>) => Effect.Effect<ClientResponse<TData>, ParseError | HttpClientError | HttpBodyError, Scope>;
}, ParseError, HttpClient.HttpClient>;
declare const StorefrontClient_base: Context.TagClass<StorefrontClient, "@solidifront/storefront-client/StorefrontClient", (initOptions: ClientOptions["Encoded"]) => MakeResult>;
declare class StorefrontClient extends StorefrontClient_base {
}
export type MakeReturn<GeneratedQueries extends CodegenOperations = StorefrontQueries, GeneratedMutations extends CodegenOperations = StorefrontMutations> = Effect.Effect<{
	query: <const Query extends string>(query: Query, options?: RequestOptions<GeneratedQueries[Query]["variables"]>) => Effect.Effect<ClientResponse<GeneratedQueries[Query]["return"]>, ParseError | HttpClientError | ExtractOperationNameError | HttpBodyError, never>;
	mutate: <const Mutation extends string>(mutation: Mutation, options?: RequestOptions<GeneratedMutations[Mutation]["variables"]>) => Effect.Effect<ClientResponse<GeneratedMutations[Mutation]["return"]>, ParseError | HttpClientError | ExtractOperationNameError | HttpBodyError, never>;
}, never, StorefrontClient | HttpClient$1>;
export declare const make: <GeneratedQueries extends CodegenOperations = StorefrontQueries, GeneratedMutations extends CodegenOperations = StorefrontMutations>(options: ClientOptions["Encoded"]) => MakeReturn<GeneratedQueries, GeneratedMutations>;
export declare const Default: Layer$1<HttpClient$1 | StorefrontClient, never, never>;

export {};
