// Generated by dts-bundle-generator v9.5.1

import * as Data from 'effect/Data';
import * as Logger from 'effect/Logger';
import * as Redacted from 'effect/Redacted';
import * as S from 'effect/Schema';

export interface CodegenOperations {
	[key: string]: any;
}
export interface StorefrontQueries extends CodegenOperations {
}
export interface StorefrontMutations extends CodegenOperations {
}
export type ClientOptions = typeof ClientOptions;
export type ValidVersion = S.Schema.Type<typeof ValidVersion>;
export type GraphQLJsonBody = S.Schema.Type<typeof GraphQLJsonBody>;
export type RequestOptionsWithoutVariables = Omit<S.Schema.Encoded<typeof RequestOptions>, "variables">;
export type RequestOptions<TVariables = any> = TVariables extends {
	[key: string]: never;
} | undefined | never ? RequestOptionsWithoutVariables : Omit<S.Schema.Encoded<typeof RequestOptions>, "variables"> & {
	variables: TVariables;
};
export declare const ValidVersion: S.Literal<[
	"2024-01",
	"2024-04",
	"2024-07",
	"2024-10",
	"2025-01",
	"unstable"
]>;
declare const ClientOptions: S.Schema<{
	readonly apiVersion: "2024-01" | "2024-04" | "2024-07" | "2024-10" | "2025-01" | "unstable";
	readonly storeName: string;
	readonly retries: number;
	readonly contentType: "json" | "graphql";
} & {
	readonly privateAccessToken?: Redacted.Redacted<string> | undefined;
	readonly publicAccessToken?: string | undefined;
}, {
	readonly storeName: string;
	readonly apiVersion?: "2024-01" | "2024-04" | "2024-07" | "2024-10" | "2025-01" | "unstable" | undefined;
	readonly retries?: number | undefined;
	readonly contentType?: "json" | "graphql" | undefined;
} & {
	readonly privateAccessToken?: string | undefined;
	readonly publicAccessToken?: string | undefined;
}, never>;
declare const GraphQLJsonBody: S.Struct<{
	data: S.optional<typeof S.Unknown>;
	extensions: S.optional<S.Record$<typeof S.String, typeof S.Any>>;
	errors: S.optional<S.Array$<S.Struct<{
		message: typeof S.NonEmptyString;
		locations: S.optional<S.Array$<S.Struct<{
			line: typeof S.Int;
			column: typeof S.Int;
		}>>>;
		extensions: S.optional<S.Struct<{
			code: typeof S.NonEmptyString;
		}>>;
	}>>>;
}>;
declare const RequestOptions: S.SchemaClass<{
	readonly privateAccessToken?: Redacted.Redacted<string> | undefined;
	readonly publicAccessToken?: string | undefined;
	readonly apiVersion?: "2024-01" | "2024-04" | "2024-07" | "2024-10" | "2025-01" | "unstable" | undefined;
	readonly storeName?: string | undefined;
	readonly contentType?: "json" | "graphql" | undefined;
	readonly buyerIp?: string | undefined;
	readonly variables?: {
		readonly [x: string]: any;
	} | undefined;
	readonly signal?: AbortSignal | undefined;
}, {
	readonly privateAccessToken?: string | undefined;
	readonly publicAccessToken?: string | undefined;
	readonly apiVersion?: "2024-01" | "2024-04" | "2024-07" | "2024-10" | "2025-01" | "unstable" | undefined;
	readonly storeName?: string | undefined;
	readonly contentType?: "json" | "graphql" | undefined;
	readonly buyerIp?: string | undefined;
	readonly variables?: {
		readonly [x: string]: any;
	} | undefined;
	readonly signal?: AbortSignal | undefined;
}, never>;
export interface IFetchBodyResponse<TData = any> {
	data?: TData;
	extensions?: Record<string, any>;
}
export interface IResponseErrors {
	networkStatusCode?: number;
	message?: string;
	graphQLErrors?: GraphQLJsonBody["errors"];
}
export interface IClientResponse<TData = any> extends IFetchBodyResponse<TData> {
	errors?: IResponseErrors;
}
declare class ClientResponse<TData = any> extends Data.Class<IClientResponse<TData>> {
}
export declare namespace createStorefrontClient {
	type Options = ClientOptions["Encoded"] & {
		logger?: Parameters<typeof Logger.make>[0];
	};
	type Variables<Operation extends string, GeneratedOperations extends CodegenOperations = StorefrontQueries | StorefrontMutations> = GeneratedOperations[Operation]["variables"];
	type ReturnData<Operation extends string, GeneratedOperations extends CodegenOperations = StorefrontMutations | StorefrontMutations> = GeneratedOperations[Operation]["return"];
	type Return<Operation extends string, GeneratedOperations extends Record<string, {
		return: any;
	}>> = Promise<ClientResponse<GeneratedOperations[Operation]["return"]>>;
}
export declare const createStorefrontClient: <GeneratedQueries extends CodegenOperations = StorefrontQueries, GeneratedMutations extends CodegenOperations = StorefrontMutations>({ logger, ...initOptions }: createStorefrontClient.Options) => {
	mutate: <const Mutation extends string>(mutation: Mutation, options?: RequestOptions<GeneratedMutations[Mutation]["variables"]>) => Promise<ClientResponse<GeneratedMutations[Mutation]["return"]>>;
	query: <const Query extends string>(query: Query, options?: RequestOptions<GeneratedQueries[Query]["variables"]>) => Promise<ClientResponse<GeneratedQueries[Query]["return"]>>;
};

export {};
